# This file was generated by mettle.genes.db.GenPy3 [ver 2.1] on Tue Mar 30 15:41:12 2021
#  Target Database = postgresql
#
import copy
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

from bs_loco.db.tables.imsg_req_for_archive import iMsgReqForArchive
from bs_loco.db.tables.msg_req import tMsgReq

class dMsgReqForArchive:

    def __init__(self, dbcon: mettle.db.IConnect):
        """
        Constructor.

        :param dbcon: Mettle database connection object.
        """
        self._dbcon   = dbcon
        self._dbstmnt = None
        self.irec     = iMsgReqForArchive()
        self.orec     = tMsgReq()

    def __del__(self):
        """
        Destructor.
        """
        del self._dbstmnt

    def __enter__(self):
        """
        With statement enter.
        """
        return self

    def __exit__(self, type, value, traceback):
        """
        With statement exit.
        """
        self._destroy()

    def _destroy(self):
        if self._dbstmnt == None:
            return

        del self._dbstmnt
        self._dbstmnt = None

    def exec_deft(self,
                  arch_date: datetime.datetime) -> "dMsgReqForArchive":
        """
        Execute the query by setting all the inputs.

        :param arch_date: datetime.datetime
        :return: Self for convenience.
        """
        self.irec.arch_date = arch_date

        return self.exec()

    def exec(self, irec: iMsgReqForArchive = None) -> "dMsgReqForArchive":
        """
        Execute the query, optionally passing in the input rec.

        :param irec:
        :return: Self for convenience.
        """
        if irec:
            self.irec._copy_from(irec)

        self._destroy()

        self._dbstmnt = self._dbcon.statement("MsgReqForArchive", self._dbcon.STMNT_TYPE_READ)

        self._dbstmnt.sql("""SELECT
  r.*
FROM
  loco.msgreq r
WHERE
  r.status in ('R', 'C', 'X') AND
  r.time_to_send < :archDate""")

        self._dbstmnt.bind_in("archDate", self.irec.arch_date, datetime.datetime)

        self._dbstmnt.bind_out("id", int, 8)
        self._dbstmnt.bind_out("notype_id", str, 128)
        self._dbstmnt.bind_out("priority", int, 4)
        self._dbstmnt.bind_out("status", str, 1)
        self._dbstmnt.bind_out("time_req", datetime.datetime)
        self._dbstmnt.bind_out("time_to_send", datetime.datetime)
        self._dbstmnt.bind_out("time_proc", datetime.datetime)
        self._dbstmnt.bind_out("msg_addr", dict)
        self._dbstmnt.bind_out("msg_dict", dict)
        self._dbstmnt.bind_out("cust_res", bool)
        self._dbstmnt.bind_out("meta_data", dict)
        self._dbstmnt.bind_out("modified_by", str, 128)
        self._dbstmnt.bind_out("tm_stamp", datetime.datetime)

        self._dbcon.execute(self._dbstmnt)

        if irec:
            irec._copy_from(self.irec)

        return self

    def fetch(self) -> bool:
        """
        Fetches the next row from the executed query.

        :return: True if a row is retreived.
        """
        if not self._dbcon.fetch(self._dbstmnt):
            return False

        self.orec.id = self._dbstmnt.result[0]
        self.orec.notype_id = self._dbstmnt.result[1]
        self.orec.priority = self._dbstmnt.result[2]
        self.orec.status = self._dbstmnt.result[3]
        self.orec.time_req = self._dbstmnt.result[4]
        self.orec.time_to_send = self._dbstmnt.result[5]
        self.orec.time_proc = self._dbstmnt.result[6]
        self.orec.msg_addr = self._dbstmnt.result[7]
        self.orec.msg_dict = self._dbstmnt.result[8]
        self.orec.cust_res = self._dbstmnt.result[9]
        self.orec.meta_data = self._dbstmnt.result[10]
        self.orec.modified_by = self._dbstmnt.result[11]
        self.orec.tm_stamp = self._dbstmnt.result[12]

        return True

    def fetch_all(self, outList: tMsgReq.List, clearList: bool = True) -> int:
        """
        Fetch all the rows into the specified list and return the list count.

        :param outList:
        :param clearList:
        :return: Number of rows fetched.
        """
        if clearList:
            outList.clear()

        while self.fetch():
            outList.append(copy.deepcopy(self.orec))

        return len(outList)

