# This file was generated by mettle.genes.db.GenPy3 [ver 2.1] on Tue Mar 30 15:41:12 2021
#  Target Database = postgresql
#
import asyncio
import copy
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

from bs_loco.db.tables.corr_prov import tCorrProv
from bs_loco.db.tables.corr_prov_key import tCorrProvKey

from .corr_prov_lock_one import dCorrProvLockOne
from .corr_prov_select_one import dCorrProvSelectOne
from .corr_prov_update import dCorrProvUpdate
from .corr_prov_insert import dCorrProvInsert
from .corr_prov_delete_one import dCorrProvDeleteOne

class dCorrProv:

    def __init__(self, dbcon: mettle.db.IAConnect):
        """
        Constructor.

        :param dbcon: Mettle database connection object.
        """
        self.rec    = tCorrProv()
        self._dbcon = dbcon

    def __enter__(self):
        """
        DAO enter.
        """
        return self

    def __exit__(self, type, value, traceback):
        """
        DAO exit.
        """
        pass

    async def lock_one(self, _lock4update: mettle.db.DBLock, _expected: bool = True) -> bool:
        """
        Lock and select the record.

        :param _lock4update: The db lock object to use.
        :param _expected: If set to false, will not raise if record is not found.
        :return: True if selected, False if not found and _expected is set to False
        """
        _key = tCorrProvKey()

        self.rec._write_key(_key)

        return await self.lock_one_by_key(_key, _lock4update, _expected)

    async def lock_one_with(self, _rec: tCorrProv, _lock4update: mettle.db.DBLock, _expected: bool = True) -> bool:
        """
        Lock and select the record using a record.

        :param _rec: The table rec to select with and into.
        :param _lock4update: The db lock object to use.
        :param _expected: If set to false, will not raise if record is not found.
        :return: True if selected, False if not found and _expected is set to False
        """
        _key = tCorrProvKey()
        _rec._write_key(_key)

        await self.lock_one_by_key(_key, _lock4update, _expected)
        _rec._copy_from(self.rec)
        return True

    async def lock_one_deft(self,
                            id: str,
                            corrtype_id: str,
                            _lock4update: mettle.db.DBLock,
                            _expected: bool = True) -> bool:
        """
        Attempt to lock and select the record by it's primary key columns.

        :param id: str
        :param corrtype_id: str
        :param _lock4update:  The db lock object to use. 
        :param _expected: bool
        """
        _key = tCorrProvKey()

        _key.id = id
        _key.corrtype_id = corrtype_id

        return await self.lock_one_by_key(_key, _lock4update, _expected)

    async def lock_one_by_key(self, _key: tCorrProvKey, _lock4update: mettle.db.DBLock, _expected: bool = True) -> bool:
        """
        Attempt to lock and select the record with it's primary key.

        :param _key: Primary key of the table record.
        :param _lock4update: The db lock object to use.
        :param _expected: If set to false, will not raise if record is not found.
        :return: True if selected, False if not found and _expected is set to False
        """
        with dCorrProvLockOne(self._dbcon) as _qry:
            _dex = _lock4update.retrys - 1 if _lock4update.retrys > 0 else 0

            while _dex >= 0:
                try:
                    await _qry.exec(_key)
                    if not await _qry.fetch():
                        if not _expected:
                            return False

                        raise mettle.lib.xMettle("LockOne failed to return a record (dCorrProv)")

                    break
                except mettle.lib.xMettle as _x:
                    if _x.get_error_code() != mettle.lib.xMettle.eCode.DBLockNoWaitFailed:
                        raise _x

                    if _dex == 0:
                        raise mettle.lib.xMettle("Could not lock CorrProv record after %d attempt(s) at %d mili second intervals!" % (
_lock4update.retrys, _lock4update.mili_seconds), errCode = mettle.lib.xMettle.eCode.DBLockNoWaitFailed)

                    if _lock4update.mili_seconds > 0:
                        await asyncio.sleep(_lock4update.mili_seconds * 0.001)
                _dex -= 1

            self.rec = _qry.orec

            return True

    async def try_select_one(self) -> bool:
        """
        Attempt to select the record.

        :return: True if the record was found.
        """
        _key = tCorrProvKey()

        self.rec._write_key(_key)

        return await self.try_select_one_by_key(_key)

    async def try_select_one_with(self, _rec: tCorrProv) -> bool:
        """
        Attempt to select the record using a table rec.

        :param _rec: The table rec to select with and into.
        :return: True if the row as selectd.
        """
        _key = tCorrProvKey()
        _rec._write_key(_key)

        if not await self.try_select_one_by_key(_key):
            return False

        _rec._copy_from(self.rec)

        return True

    async def try_select_one_deft(self,
                                  id: str,
                                  corrtype_id: str) -> bool:
        """
        Attempt to select the record by it's primary key columns.

        :param id: str
        :param corrtype_id: str
        :return: True if the row as selectd.
        """
        _key = tCorrProvKey()

        _key.id = id
        _key.corrtype_id = corrtype_id

        return await self.try_select_one_by_key(_key)

    async def try_select_one_by_key(self, _key: tCorrProvKey) -> bool:
        """
        Attempt to select the record with it's primary key.

        :param _key: Primary key of the table record.
        :returns: True if row was selected.
        """
        with dCorrProvSelectOne(self._dbcon) as _qry:
            await _qry.exec(_key)
            if not await _qry.fetch():
                return False

            self.rec = _qry.orec

        return True

    async def select_one(self) -> "dCorrProv":
        """
        Selects the record, raises and error if it does not exist.

        :return: Self for convenience.
        """
        if not await self.try_select_one():
            raise mettle.lib.xMettle("SelectOne failed to return a record (dCorrProv)")

        return self

    async def select_one_with(self, _rec: tCorrProv) -> "dCorrProv":
        """
        Attempt to select the record with the table record.

        :param _rec: Table record.
        :returns: Self for convenience.
        """
        if not await self.try_select_one_with(_rec):
            raise mettle.lib.xMettle("SelectOne failed to return a record (dCorrProv)")

        return self

    async def select_one_deft(self,
                              id: str,
                              corrtype_id: str) -> "dCorrProv":
        """
        Selects the record by its primary key columns, raises and error if it does not exist.

        :param id: str
        :param corrtype_id: str
        """
        _key = tCorrProvKey()

        _key.id = id
        _key.corrtype_id = corrtype_id

        if not await self.try_select_one_by_key(_key):
            raise mettle.lib.xMettle("SelectOne failed to return a record (dCorrProv)")

        return self

    async def select_one_by_key(self, _key: tCorrProvKey) -> "dCorrProv":
        """
        Attempt to select the record with it's primary key.

        :param _key: Primary key of the table record.
        :return: Self for convenience.
        """
        if not await self.try_select_one_by_key(_key):
            raise mettle.lib.xMettle("SelectOne failed to return a record (dCorrProv)")

        return self

    async def update_deft(self,
                          id: str,
                          corrtype_id: str,
                          descr: str,
                          status: str,
                          cfg_schema: dict,
                          cfg: dict,
                          lastcfg_id: int,
                          modified_by: str):
        """
        Update the record by setting all column values.

        :param id: str
        :param corrtype_id: str
        :param descr: str
        :param status: str
        :param cfg_schema: dict
        :param cfg: dict
        :param lastcfg_id: int
        :param modified_by: str
        :param tm_stamp: datetime.datetime
        """
        self.rec.id = id
        self.rec.corrtype_id = corrtype_id
        self.rec.descr = descr
        self.rec.status = status
        self.rec.cfg_schema = cfg_schema
        self.rec.cfg = cfg
        self.rec.lastcfg_id = lastcfg_id
        self.rec.modified_by = modified_by

        await self.update()

    async def update(self, irec: tCorrProv = None):
        """
        Update the record in the database with the record or irec if it is not None.

        :param irec: If not None use this record to update the database.
        """
        if irec:
            self.rec._copy_from(irec)

        with dCorrProvUpdate(self._dbcon) as _qry:
            await _qry.exec(self.rec)

        if irec:
            irec._copy_from(self.rec)

    async def insert_deft(self,
                          id: str,
                          corrtype_id: str,
                          descr: str,
                          status: str,
                          cfg_schema: dict,
                          cfg: dict,
                          lastcfg_id: int,
                          modified_by: str):
        """
        Insert the record setting all column values.

        :param id: str
        :param corrtype_id: str
        :param descr: str
        :param status: str
        :param cfg_schema: dict
        :param cfg: dict
        :param lastcfg_id: int
        :param modified_by: str
        :param tm_stamp: datetime.datetime
        """
        self.rec.id = id
        self.rec.corrtype_id = corrtype_id
        self.rec.descr = descr
        self.rec.status = status
        self.rec.cfg_schema = cfg_schema
        self.rec.cfg = cfg
        self.rec.lastcfg_id = lastcfg_id
        self.rec.modified_by = modified_by

        await self.insert()

    async def insert(self, irec: tCorrProv = None):
        """
        Insert the record in the database with the record or irec if it is not None.

        :param irec: If not None use this record to insert into the database.
        """
        if irec:
            self.rec._copy_from(irec)

        with dCorrProvInsert(self._dbcon) as _qry:
            await _qry.exec(self.rec)

        if irec:
            irec._copy_from(self.rec)

    async def delete_one_deft(self,
                              id: str,
                              corrtype_id: str):
        """
        Delete one record by it's primary key columns.

        :param id: str
        :param corrtype_id: str
        """
        _key = tCorrProvKey()

        _key.id = id
        _key.corrtype_id = corrtype_id

        await self.delete_one(_key)

    async def delete_one(self, irec: tCorrProvKey = None):
        """
        Delete the record by its primary key or irec if it is not None.

        :param irec: If not None use this record to delete record.
        """
        _key = tCorrProvKey()

        if irec:
            _key._copy_from(irec)
        else:
            self.rec._write_key(_key)

        with dCorrProvDeleteOne(self._dbcon) as _qry:
            await _qry.exec(_key)

